/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.gruppeimgebiet.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet;
import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietUK;

public abstract class AbstractGruppeImGebietDAO extends de.ivu.elect.jee.entity.AbstractDAO<GruppeImGebiet,
        de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietPK
    , GruppeImGebietUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractGruppeImGebietDAO.class);

  public AbstractGruppeImGebietDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public GruppeImGebiet findByPrimaryKey(
        de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected GruppeImGebiet findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(GruppeImGebiet.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: CountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiertAndRelativePositionIsNotNullNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select count(o) from GruppeImGebiet o where o.gebiet = ?1 and o.gruppe.gruppeArt != ?2 and o.vorgegebenePosition IS NOT NULL and o.relativePosition is not null<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiertAndRelativePositionIsNotNull( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.CountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiertAndRelativePositionIsNotNull")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiertAndRelativePositionIsNotNull - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiertAndRelativePositionIsNotNull - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiertAndRelativePositionIsNotNull(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiertNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select count(o) from GruppeImGebiet o where o.gebiet = ?1 and o.gruppe.gruppeArt != ?2 and o.vorgegebenePosition IS NOT NULL<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiert( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.CountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiert")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiert - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiert - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionFixiert(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionNichtFixiertAndRelativePositionIsNotNullNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select count(o) from GruppeImGebiet o where o.gebiet = ?1 and o.gruppe.gruppeArt != ?2 and o.vorgegebenePosition IS NULL and o.relativePosition is not null<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionNichtFixiertAndRelativePositionIsNotNull( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.CountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionNichtFixiertAndRelativePositionIsNotNull")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionNichtFixiertAndRelativePositionIsNotNull - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndPositionNichtFixiertAndRelativePositionIsNotNull(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNotNullNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select count(o) from GruppeImGebiet o where o.gebiet = ?1 and o.gruppe.gruppeArt != ?2 and o.relativePosition is not null<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNotNull( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.CountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNotNull")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNotNull - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNotNull - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNotNull(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNullNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select count(o) from GruppeImGebiet o where o.gebiet = ?1 and o.gruppe.gruppeArt != ?2 and o.relativePosition is null<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNull( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.CountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNull")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNull - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNull - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountGruppeImGebietByGebietAndUngleichGruppeArtAndRelativePositionIsNull(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountPositionenFuerGruppeNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM GruppeImGebiet o WHERE o.gruppe=?1<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountPositionenFuerGruppe( @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gruppe.entity.Gruppe gruppeCheckedAndAttached =  checkAndAttach(gruppe, de.ivu.elect.business.gruppe.entity.Gruppe.class, "gruppe"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.CountPositionenFuerGruppe")
                              .setParameter(1, gruppeCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountPositionenFuerGruppe - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByCountPositionenFuerGruppe - NonUniqueResultException, Parameter: "
           + ", gruppe:'"+gruppe+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountPositionenFuerGruppe(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietAndGruppeArtNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from GruppeImGebiet o where o.gebiet = ?1 and o.gruppe.gruppeArt = ?2<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByGebietAndGruppeArt( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.GebietAndGruppeArt")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebietAndGruppeArt - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByGebietAndGruppeArt - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebietAndGruppeArt(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietAndGruppeArtenNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from GruppeImGebiet o where o.gebiet = ?1 and o.gruppe.gruppeArt IN (?2)<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByGebietAndGruppeArten( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gruppe.entity.GruppeArt> gruppeArten) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  java.util.Collection<de.ivu.elect.business.gruppe.entity.GruppeArt> gruppeArtenCheckedAndAttached =  gruppeArten ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.GebietAndGruppeArten")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, gruppeArtenCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebietAndGruppeArten - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByGebietAndGruppeArten - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", gruppeArten:'"+gruppeArten+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebietAndGruppeArten(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietAndRelativePositionNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM GruppeImGebiet obj WHERE obj.gebiet = ?1 AND obj.relativePosition = ?2<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByGebietAndRelativePosition( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull java.lang.Long relativePosition) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  java.lang.Long relativePositionCheckedAndAttached =  relativePosition ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.GebietAndRelativePosition")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, relativePositionCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebietAndRelativePosition - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByGebietAndRelativePosition - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", relativePosition:'"+relativePosition+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebietAndRelativePosition(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietAndUngleichGruppeArtOrderByRelativePositionNoFlush<br>
      * Beschreibung: Anzeige der Gruppen eines Gebietes<br>
      * EJBQL: select o from GruppeImGebiet o where o.gebiet = ?1 and o.gruppe.gruppeArt != ?2 order by o.relativePosition<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByGebietAndUngleichGruppeArtOrderByRelativePosition( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.GebietAndUngleichGruppeArtOrderByRelativePosition")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebietAndUngleichGruppeArtOrderByRelativePosition - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByGebietAndUngleichGruppeArtOrderByRelativePosition - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebietAndUngleichGruppeArtOrderByRelativePosition(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from GruppeImGebiet o where o.gebiet = ?1<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.Gebiet")
                              .setParameter(1, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByGebiet - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietOrderByRelativePositionNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from GruppeImGebiet o where o.gebiet = ?1 order by o.relativePosition<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByGebietOrderByRelativePosition( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.GebietOrderByRelativePosition")
                              .setParameter(1, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebietOrderByRelativePosition - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByGebietOrderByRelativePosition - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebietOrderByRelativePosition(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebieteAndGruppeArtNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from GruppeImGebiet o where o.gebiet in ?1 and o.gruppe.gruppeArt = ?2<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByGebieteAndGruppeArt( @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebiete,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebieteCheckedAndAttached =  gebiete ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.GebieteAndGruppeArt")
                              .setParameter(1, gebieteCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebieteAndGruppeArt - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByGebieteAndGruppeArt - NonUniqueResultException, Parameter: "
           + ", gebiete:'"+gebiete+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebieteAndGruppeArt(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GruppeAndGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from GruppeImGebiet o where o.gruppe = ?1 and o.gebiet = ?2<br>
      * SQL: <br>
      */
     public GruppeImGebiet findByGruppeAndGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gruppe.entity.Gruppe gruppeCheckedAndAttached =  checkAndAttach(gruppe, de.ivu.elect.business.gruppe.entity.Gruppe.class, "gruppe"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                    (GruppeImGebiet)
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.GruppeAndGebiet")
                              .setParameter(1, gruppeCheckedAndAttached)
                                        .setParameter(2, gebietCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGruppeAndGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByGruppeAndGebiet - NonUniqueResultException, Parameter: "
           + ", gruppe:'"+gruppe+"'"
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGruppeAndGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GruppeNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from GruppeImGebiet o where o.gruppe = ?1<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByGruppe( @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gruppe.entity.Gruppe gruppeCheckedAndAttached =  checkAndAttach(gruppe, de.ivu.elect.business.gruppe.entity.Gruppe.class, "gruppe"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.Gruppe")
                              .setParameter(1, gruppeCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGruppe - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByGruppe - NonUniqueResultException, Parameter: "
           + ", gruppe:'"+gruppe+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGruppe(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: MaxRelativePositionNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT MAX(obj.relativePosition) FROM GruppeImGebiet obj WHERE obj.gebiet = ?1 AND obj.gruppe.gruppeArt = ?2<br>
      * SQL: <br>
      */
     public java.lang.Long findByMaxRelativePosition( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.MaxRelativePosition")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByMaxRelativePosition - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByMaxRelativePosition(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: RelativePositionImGebietZuruecksetzenUngleichGruppeArtNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: UPDATE GruppeImGebiet SET relativePosition=NULL WHERE gebiet=?1 AND gruppe.gruppeArt != ?2<br>
      * SQL: <br>
      */
     public Integer updateRelativePositionImGebietZuruecksetzenUngleichGruppeArt( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.RelativePositionImGebietZuruecksetzenUngleichGruppeArt")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .executeUpdate();
                    
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("updateRelativePositionImGebietZuruecksetzenUngleichGruppeArt - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, updateRelativePositionImGebietZuruecksetzenUngleichGruppeArt - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".updateRelativePositionImGebietZuruecksetzenUngleichGruppeArt(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: UngleichGruppeArtNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from GruppeImGebiet o where o.gruppe.gruppeArt != ?1<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByUngleichGruppeArt( @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.UngleichGruppeArt")
                              .setParameter(1, gruppeArtCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByUngleichGruppeArt - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByUngleichGruppeArt - NonUniqueResultException, Parameter: "
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByUngleichGruppeArt(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndGebietsartNameAndGebietNummerNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM GruppeImGebiet o WHERE o.gruppe.wahl = ?1 AND o.gebiet.gebietsart.name = ?2 AND o.gebiet.nummer = ?3<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByWahlAndGebietsartNameAndGebietNummer( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String gebietsartName,  @javax.annotation.Nonnull String gebietsNummer) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String gebietsartNameCheckedAndAttached =  checkAndAttach(gebietsartName, String.class, "gebietsartName"); ;
		  			  String gebietsNummerCheckedAndAttached =  checkAndAttach(gebietsNummer, String.class, "gebietsNummer"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.WahlAndGebietsartNameAndGebietNummer")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, gebietsartNameCheckedAndAttached)
                                        .setParameter(3, gebietsNummerCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndGebietsartNameAndGebietNummer - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByWahlAndGebietsartNameAndGebietNummer - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", gebietsartName:'"+gebietsartName+"'"
           + ", gebietsNummer:'"+gebietsNummer+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndGebietsartNameAndGebietNummer(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndGruppeNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM GruppeImGebiet o JOIN FETCH o.gebiet WHERE o.gruppe.wahl = ?1 AND o.gruppe = ?2<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByWahlAndGruppe( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.gruppe.entity.Gruppe gruppeCheckedAndAttached =  checkAndAttach(gruppe, de.ivu.elect.business.gruppe.entity.Gruppe.class, "gruppe"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.WahlAndGruppe")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, gruppeCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndGruppe - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByWahlAndGruppe - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", gruppe:'"+gruppe+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndGruppe(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndNameOrKurznameNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM GruppeImGebiet o JOIN FETCH o.gebiet WHERE o.gruppe.wahl = ?1 AND (o.name = ?2 OR o.kurzname = ?2)<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByWahlAndNameOrKurzname( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.lang.String nameOrKurzname) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.lang.String nameOrKurznameCheckedAndAttached =  nameOrKurzname ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.WahlAndNameOrKurzname")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, nameOrKurznameCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndNameOrKurzname - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByWahlAndNameOrKurzname - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", nameOrKurzname:'"+nameOrKurzname+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndNameOrKurzname(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndRelativePositionIsNullNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM GruppeImGebiet o WHERE o.gruppe.wahl = ?1 AND o.relativePosition IS NULL<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByWahlAndRelativePositionIsNull( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.WahlAndRelativePositionIsNull")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndRelativePositionIsNull - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByWahlAndRelativePositionIsNull - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndRelativePositionIsNull(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndUngleichGruppeArtEagerNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM GruppeImGebiet o JOIN FETCH o.gebiet JOIN FETCH o.gruppe WHERE o.gruppe.wahl = ?1 AND o.gruppe.wahl = ?1 AND o.gruppe.gruppeArt != ?2<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByWahlAndUngleichGruppeArtEager( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.gruppe.entity.GruppeArt gruppeArtCheckedAndAttached =  checkAndAttach(gruppeArt, de.ivu.elect.business.gruppe.entity.GruppeArt.class, "gruppeArt"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.WahlAndUngleichGruppeArtEager")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, gruppeArtCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndUngleichGruppeArtEager - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByWahlAndUngleichGruppeArtEager - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", gruppeArt:'"+gruppeArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndUngleichGruppeArtEager(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlEagerNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM GruppeImGebiet o JOIN FETCH o.gebiet JOIN FETCH o.gruppe WHERE o.gruppe.wahl = ?1 AND o.gruppe.wahl = ?1<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByWahlEager( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.WahlEager")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlEager - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByWahlEager - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlEager(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM GruppeImGebiet o WHERE o.gruppe.wahl = ?1<br>
      * SQL: <br>
      */
     public java.util.List<GruppeImGebiet> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GRUPPE_IM_GEBIET.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("GruppeImGebiet, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietUK uk,
        de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet findByUK(de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietUK uk){

    try {
     return (de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet) getEntityManager().createNamedQuery("GRUPPE_IM_GEBIET.UK")
                  .setParameter(1, uk
                .getGebietUK ()  
                .getNummer ()  
              )
             .setParameter(2, uk
                .getGebietUK ()  
                .getGebietsartUK ()  
                .getName ()  
              )
             .setParameter(3, uk
                .getGebietUK ()  
                .getGebietsartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(4, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(5, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(6, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(7, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(8, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(9, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(10, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(11, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(12, uk
                .getGruppeUK ()  
                .getSchluessel ()  
              )
             .setParameter(13, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(14, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(15, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(16, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(17, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("GruppeImGebiet, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}